Subject: Re: PATCH: fix bridged 802.3ad bonding

From: Patrick McHardy <[email-masked]>
Date: Tue, 03 Jun 2008 16:13:13 +0200

Jiri Bohac wrote:
> Hi,
> 
> Bonding in 802.3ad mode breaks when the bond interface is added
> to a bridge (which makes 802.3ad unusable in XEN, for example).
> 
> The problem is that br_pass_frame_up() will change the skb's dev
> pointer to point to the bridge interface. As a result, the LACP
> packets will not reach the bond_3ad_lacpdu_recv() protocol
> handler registered on the bonding device. Even if they did, the
> handler won't work with the changed skb->dev.
> 
> The following patch fixes the problem.

This shouldn't be done in the core code. How about handling this
in either the bridging code or registering the ptype handler for
the briding device?